/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package socketclient;

/**
 *
 * @author francois
 */

// Pour l'interface utilisateur
import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.event.*;
import javax.swing.*;

import java.io.*;  // entrées-sorties
import java.net.*; // network

class SocketClient extends JFrame   // JFrame : fenêtre principale de l'application
                   implements ActionListener { // gérer le bouton envoyer

    JLabel label1, label2;      // deux labels
    JButton button;             // le bouton 'Send'
    JPanel panel1, panel2;      // deux panneaux
    JTextField textField;       // un champ de texte
    JTextArea textArea;         // une zone de texte

    Socket socket = null;       // le socket
    PrintWriter out = null;
    BufferedReader in = null;

    SocketClient() { //Begin Constructor
           // construction du 'cadre' composé d'un 'panneau' avec des champs de texte et un bouton 'Send'
         label1 = new JLabel("Text to send over socket:");
         label2 = new JLabel("Text received over socket:");
         textField = new JTextField(30);
         textArea = new JTextArea();
         button = new JButton("Send"); // bouton envoyer
         button.addActionListener(this);

         panel1 = new JPanel(); // 1er panneau
         panel1.setLayout(new BorderLayout());
         panel1.setBackground(Color.white);

         panel1.add("North", label1);
         panel1.add("Center", textField);
         panel1.add("South", button);

         panel2 = new JPanel(); // 2e panneau
         panel2.setLayout(new BorderLayout());
         panel2.setBackground(Color.white);

         panel2.add("North", panel1); // 1er panneau inclus dans le 2e
         panel2.add("Center", label2);
         panel2.add("South", textArea);
         getContentPane().add(panel2); // 2e panneau dans la fenêtre


    } //End Constructor

    public void actionPerformed(ActionEvent event) { // gestion des évènements

        Object source = event.getSource();

        if(source == button) {
            //Send data over socket
            String text = textField.getText();
            out.println(text);                    // écrire vers out
            textField.setText(new String(""));

            //Receive text from server
            try {
                  String line = in.readLine();        // lire depuis in
                  System.out.println("Text received :" + line);
                  textArea.setText(line);
            } catch (IOException e){
                 System.out.println("Read failed");
                 System.exit(1);
            }
          }
    }

    public void listenSocket(){ // par défaut se connecter à 127.0.0.1:4444
        try {
            //Create socket connection
            this.listenSocket(InetAddress.getByName("localhost"), 4444);

        } catch (UnknownHostException e) {
            System.out.println("Unknown host: localhost");
            System.exit(1);
        } catch  (IOException e) {
                System.out.println("No I/O");
                System.exit(1);
        }
    }

    public void listenSocket(InetAddress server_address, int server_port){
        //Create socket connection
        try{
           socket = new Socket(server_address, server_port); // se connecter au socket serveur
           System.out.println("Client : connexion sur "+server_address.toString()+":"+server_port);


           out = new PrintWriter(socket.getOutputStream(), true); // créer le flux d'écriture
           in = new BufferedReader(new InputStreamReader(socket.getInputStream())); // créer le flux de lecture
           
        } catch (UnknownHostException e) {
               System.out.println("Unknown host: "+server_address.toString());
               System.exit(1);
               
        } catch  (IOException e) {
               System.out.println("No I/O");
               System.exit(1);
        }
    }

    public static void main(String[] args){

        SocketClient frame = new SocketClient();    // instancier la fenêtre

        frame.setTitle("Client Program");           // titre de la fenêtre du client 

        WindowListener winlisten = new WindowAdapter() {    // case de fermeture => quitter le client
            @Override
            public void windowClosing(WindowEvent e) {
                System.exit(0);    // quitter si la fenêtre est fermée
            }
        };

        frame.addWindowListener(winlisten);
        frame.pack();
        frame.setVisible(true);
        frame.listenSocket();   // se connecter au socket 127.0.0.1:4444
    }
}