/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package socketserver;

/**
 *
 * @author francois
 */

// Pour l'interface utilisateur
import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.event.*;
import javax.swing.*;

import java.io.*; // entrées-sorties
import java.net.*; // network

class SocketServer extends JFrame   // JFrame : une fenêtre
                   implements ActionListener {
    JButton button;                         // le bouton "Show the last line"
    JLabel label = new JLabel("Text received over socket:");       // un label
    JPanel panel;                           // un panneau
    JTextArea textArea = new JTextArea();   // une zone de texte

    ServerSocket sock_server = null;    // socket serveur d'écoute
    Socket sock_client = null;          // socket client accepté
    BufferedReader in = null;           // flux de lecture
    PrintWriter out = null;             // flux d'écriture
    String line;                        // dernière ligne reçue

    SocketServer() {        //Begin Constructor
         // construction d'un 'panneau' avec un champ de texte et un bouton
      button = new JButton("Show the last line");   // le bouton "Show the last line"
      button.addActionListener(this);               // que fait ce bouton ?

      panel = new JPanel();  // un panneau
      panel.setLayout(new BorderLayout());  // une mise en page basique
      panel.setBackground(Color.white);     // le fond est blanc
      panel.add("North", label);            // le label "Text received over socket:"
      panel.add("Center", textArea);        // le champ de texte
      panel.add("South", button);           // le bouton "Show the last line"
      getContentPane().add(panel);          // ajouter le panneau dans la fenêtre

    } //End Constructor

    public void actionPerformed(ActionEvent event) {
      Object source = event.getSource();

      if(source == button){                // que fait le bouton ?
          textArea.setText(line);          // copier la dernière ligne reçue dans la zone de texte
      }
    }

    public void listenSocket(){       // écouter le sock_client

     try {                            // créer le sock_server
       sock_server = new ServerSocket(4444);     // port 4444
       
     } catch (IOException e) {
       System.out.println("Could not listen on port 4444");
       System.exit(-1);
     }

     try{                            // accepter le sock_client
       sock_client = sock_server.accept();
       
     } catch (IOException e) {
       System.out.println("Accept failed: 4444");
       System.exit(-1);
     }

     try{    // flux de lecture et d'écriture
       in = new BufferedReader(new InputStreamReader(sock_client.getInputStream()));    // ouvrir un flux de lecture : in
       out = new PrintWriter(sock_client.getOutputStream(), true);                      // ouvrir un flux d'écriture : out
     
     } catch (IOException e) {
       System.out.println("BufferedReader or PrintWriter failed");
       System.exit(-1);
     }

     System.out.println("BufferedReader and PrintWriter are ready.");

     while(true) {      // indéfiniement
         try{
           line = in.readLine();                                // lire depuis sock_client
           textArea.setText(textArea.getText()+"\n\r"+line);    // ajouter line au textArea

           //Répondre vers sock_client
           if(line.toLowerCase().startsWith("bonjour")) out.println("Salut !");
           else out.println("Que veut dire : "+line+" ? ");

         } catch (IOException e) {
           System.out.println("Read failed");
           System.exit(-1);
         }
     }
    }

    protected void finalize(){ // tout refermer en partant
    //Clean up
      try{
         in.close();
         out.close();
         sock_server.close();
         
     } catch (IOException e) {
         System.out.println("Could not close.");
         System.exit(-1);
     }
    }

    public static void main(String[] args) {        // le programme principal
         SocketServer frame = new SocketServer();   // le constructeur créé une fenêtre
         frame.setTitle("Server Program");          // titre de la fenêtre
         
         WindowListener winlisten = new WindowAdapter() {   // Quitter le serveur avec la case de fermeture
                 public void windowClosing(WindowEvent e) {
                         System.exit(0);        // quitter si la fenêtre est fermée
                 }
         };
         frame.addWindowListener(winlisten);
         frame.pack();
         frame.setVisible(true);     // afficher le fenêtre
         frame.listenSocket();       // écoute du socket
    }
}

